package com.hotwj.platform.config.mediaResource.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.mediaResource.domain.HotMediaResource;
import com.hotwj.platform.config.mediaResource.domain.bo.HotMediaResourceBo;
import com.hotwj.platform.config.mediaResource.domain.vo.HotMediaResourceVo;
import com.hotwj.platform.config.mediaResource.mapper.HotMediaResourceMapper;
import com.hotwj.platform.config.mediaResource.service.IHotMediaResourceService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 视频/音频资源库Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-23
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotMediaResourceServiceImpl implements IHotMediaResourceService {

    private final HotMediaResourceMapper baseMapper;

    /**
     * 查询视频/音频资源库
     *
     * @param id 主键
     * @return 视频/音频资源库
     */
    @Override
    public HotMediaResourceVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询视频/音频资源库列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 视频/音频资源库分页列表
     */
    @Override
    public TableDataInfo<HotMediaResourceVo> queryPageList(HotMediaResourceBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotMediaResource> lqw = buildQueryWrapper(bo);
        Page<HotMediaResourceVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的视频/音频资源库列表
     *
     * @param bo 查询条件
     * @return 视频/音频资源库列表
     */
    @Override
    public List<HotMediaResourceVo> queryList(HotMediaResourceBo bo) {
        LambdaQueryWrapper<HotMediaResource> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotMediaResource> buildQueryWrapper(HotMediaResourceBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotMediaResource> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotMediaResource::getId);
//        lqw.eq(bo.getCompanyId() != null, HotMediaResource::getCompanyId, bo.getCompanyId());
        lqw.like(StringUtils.isNotBlank(bo.getName()), HotMediaResource::getName, bo.getName());
        lqw.like(StringUtils.isNotBlank(bo.getCategoryCode()), HotMediaResource::getCategoryCode, bo.getCategoryCode());
        lqw.eq(bo.getMediaType() != null, HotMediaResource::getMediaType, bo.getMediaType());
        lqw.eq(StringUtils.isNotBlank(bo.getFileUrl()), HotMediaResource::getFileUrl, bo.getFileUrl());
        lqw.eq(bo.getSizeBytes() != null, HotMediaResource::getSizeBytes, bo.getSizeBytes());
        lqw.eq(bo.getDurationSeconds() != null, HotMediaResource::getDurationSeconds, bo.getDurationSeconds());
        lqw.eq(bo.getStatus() != null, HotMediaResource::getStatus, bo.getStatus());
        lqw.eq(bo.getCreateTime() != null, HotMediaResource::getCreateTime, bo.getCreateTime());
        lqw.between(params.get("beginCreateTime") != null && params.get("endCreateTime") != null,
                HotMediaResource::getCreateTime, params.get("beginCreateTime"), params.get("endCreateTime"));
        return lqw;
    }

    /**
     * 新增视频/音频资源库
     *
     * @param bo 视频/音频资源库
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotMediaResourceBo bo) {
        HotMediaResource add = MapstructUtils.convert(bo, HotMediaResource.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改视频/音频资源库
     *
     * @param bo 视频/音频资源库
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotMediaResourceBo bo) {
        HotMediaResource update = MapstructUtils.convert(bo, HotMediaResource.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotMediaResource entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除视频/音频资源库信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
